package edu.nps.seed.nst.pp

import java.io.File
import scala.io.Source
import scala.collection.mutable.ListBuffer

class Excursion(val id:Int, val values:List[Int]) {
  val result = new ListBuffer[String]()
  var header: String = ""
  val delimiter = ","
  
  def processOutput(filestub: String,suffix: String, 
  						outputDir:File): ListBuffer[String] = {
    val filename = new File(outputDir,filestub + id.toString + suffix)
    
    val lines = Source.fromFile(filename).getLines.toList
    val data = new ListBuffer[String]()
    result.clear
    header = lines(0)
    for (line <- lines.drop(1)) {
      data += id.toString
      for (value <- values) {
        data += value.toString
      }
      data += line.stripLineEnd
      result += data.mkString(delimiter)
      data.clear
    }
    
    result
  }
  
}

object Excursion {
  
  def excursionFromXML(node: scala.xml.Node): Excursion = {
   val id = (node \ "@id").text.toInt

   val values = 
       for {
    	   value <- node \ "Value"
       } yield value.text.toInt
   
   val excursion = new Excursion(id, values.toList)
    
    excursion
  }
}
