package oldmcdata.agents.behaviors;

import jade.core.Agent;
import jade.core.behaviours.SimpleBehaviour;
import jade.domain.FIPAException;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

import java.io.PrintWriter;
import java.util.List;


/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *         
 * @author Stephen C. Upton
 * @version 1.0
 */

public class ReceiveMessageBehavior extends SimpleBehaviour {
    protected boolean finished = false;

    public ReceiveMessageBehavior(Agent a) {
        super(a);
    }

    public void action() {

    }

    protected boolean waitForMessage(PrintWriter output) {
        output.println("\nAgent " + myAgent.getLocalName() + "  is in waiting for message");
        System.out.println("\nAgent " + myAgent.getLocalName() + "  is in waiting for message");
        try {
            MessageTemplate m1 = MessageTemplate.MatchOntology("GEA");

            //The agent waits for a specific message. If it doesn't arrive the behaviour is suspended until a new message arrives.
            ACLMessage msg = myAgent.receive(m1);

            if (msg != null) {
                System.out.println("\nAgent " + myAgent.getLocalName() + " received message");
                output.println("\nAgent " + myAgent.getLocalName() + " received message");
                output.println(msg.toString());
                System.out.println(msg.toString());
//        ContentElement content = myAgent.getContentManager().extractContent(msg);
                //       Object resp = l.get(0);
                List l = myAgent.extractContent(msg);
                Object content = l.get(0);

                return true;
            } else {
                output.println("\nAgent " + myAgent.getLocalName() + " has not received message");
                block();
            }
        } // End of try
        catch (FIPAException fe) {
            System.err.println("FIPAException in fill/extract content:" + fe.getMessage());
            System.exit(-1);
        }
        return false;
    }

    public boolean done() {
        return finished;
    }
}