package oldmcdata.agents.behaviors;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.SimpleBehaviour;
import jade.domain.FIPAException;
import jade.lang.acl.ACLMessage;
import jade.lang.sl.SL0Codec;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;


/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *         
 * @author Stephen C. Upton
 * @version 1.0
 */

public class SendMessageBehavior extends SimpleBehaviour {
    protected boolean finished = false;

    public SendMessageBehavior(Agent a) {
        super(a);
    }

    public void action() {
    }

    protected void sendMessage(String receiverLocalName,
                               PrintWriter output) {
        try {
            AID r = new AID();
            r.setLocalName(receiverLocalName);
            ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
            msg.setSender(myAgent.getAID());
            msg.addReceiver(r);
            msg.setLanguage(SL0Codec.NAME);
            msg.setOntology("GEA");

            List content = new ArrayList(1);
            myAgent.fillContent(msg, content);
            myAgent.send(msg);

            output.println("\nAgent " + myAgent.getLocalName() + " sending message");
            System.out.println("\nAgent " + myAgent.getLocalName() + " has sent message");
            output.println(msg.toString());

        } catch (FIPAException fe) {
            System.err.println("FIPAException in fillContent: " + fe.getMessage());
        }
    }

    public boolean done() {
        return finished;
    }
}