/*
    
    oldmcdata1.0
    Copyright (C) 2005 Referentia Systems, Inc.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package oldmcdata.analyzers.tests;

import java.util.List;

import oldmcdata.analyzers.utils.DataReader;

import org.dom4j.DocumentHelper;
import org.dom4j.Element;

/**
 * @author Stephen C. Upton
 * @date Feb 22, 2005
 *
 */
public class DataReaderTest {
    private Element dataSelectorElement;
    private String filename;
    /**
     * 
     */
    public DataReaderTest(String filename) {
        this.filename = filename;
    }
    
    public void constructTestElement() {
        dataSelectorElement = DocumentHelper.createElement("DataSelector");
        Element skipLines = dataSelectorElement.addElement("SkipLines");
        Element numberToSkip = skipLines.addElement("Number");
        numberToSkip.setText("6");
        Element starts1 = skipLines.addElement("StartsWith");
        starts1.setText("#");
        Element starts2 = skipLines.addElement("StartsWith");
        starts2.setText("Means");
        Element starts3 = skipLines.addElement("StartsWith");
        starts3.setText("Std");
    }
    
    public void runTest() {
        constructTestElement();
        DataReader r = new DataReader();
        r.initialize(dataSelectorElement);
        r.setFileToProcess(filename);
        r.readLines();
        List lines = r.getLinesRead();
        for (int i=0;i<lines.size();i++) {
            String line = (String)lines.get(i);
        	System.out.println("i: " + line);
    	}
    }

    public static void main(String[] args) {
        System.out.println("Running DataReaderTest");
        DataReaderTest t = new DataReaderTest(args[0]);
        t.runTest();
        System.out.println("Completed DataReaderTest");
    }
}
