/*
    
    oldmcdata1.0
    Copyright (C) 2005 Referentia Systems, Inc.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package oldmcdata.analyzers.utils;

import java.util.List;
import java.util.Vector;

import org.dom4j.Element;

/**
 * @author Stephen C. Upton
 * @date Feb 22, 2005
 *
 */
public class ColumnSelector {
    private Vector columns;
    int[] columnNumbers;
    private String delimiter;
    /**
     * 
     */
    public ColumnSelector() {
        columns = new Vector();
    }

    public void initialize(Element e) {
        Element selectCols = e.element("SelectCols");
        if ( selectCols == null )
            throw new NullPointerException("SelectCols is null in DataSelector element");
        String delimiterElement = selectCols.elementText("delimiter");
        if ( delimiterElement == null )
            delimiter = ",";
        List columnElements = selectCols.elements("Col");
        int numberOfColumns = columnElements.size();
        columnNumbers = new int[numberOfColumns];
        for (int i=0;i<numberOfColumns;i++) {
            Element column = (Element)columnElements.get(i);
            String colName = column.elementText("name");
            String colNumber = column.elementText("number");
            System.out.println("colNumber: " + colNumber);
            columnNumbers[i] = Integer.parseInt(colNumber);
            DataVector columnVector = new DataVector(colName);
            columns.add(columnVector);
        }
    }
    
    public void processData(List dataLines) {
        int numberOfRows = dataLines.size();
        for (int j=0;j<columns.size();j++) {
            DataVector columnVector = (DataVector)columns.get(j);
            columnVector.setValues(numberOfRows, 0.0);
        } 
  
        for (int i=0;i<numberOfRows;i++) {
            String line = (String)dataLines.get(i);
            String[] values = line.split(delimiter);
            for (int j=0;j<columns.size();j++) {
                DataVector columnVector = (DataVector)columns.get(j);
                columnVector.setValue(i,values[columnNumbers[j]-1]);
            }
            
        }
        
    }
    
    public Vector getColumns() {
        return columns;
    }
    

}
