/*
    
    oldmcdata1.0
    Copyright (C) 2005 Referentia Systems, Inc.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package oldmcdata.analyzers.utils;

import java.util.List;
import java.util.Vector;

import org.dom4j.Element;

/**
 * @author Stephen C. Upton
 * @date Feb 22, 2005
 *
 */
public class DataSelector {
    private DataReader reader;
    private ColumnSelector colSelector;
    
    public DataSelector() {
        reader = new DataReader();
        colSelector = new ColumnSelector();
    }
    
    public void initialize(Element dataSelectorElement) {
        reader.initialize(dataSelectorElement);
        colSelector.initialize(dataSelectorElement);
    }
    
    public void setFileToProcess(String filename) {
        reader.setFileToProcess(filename);

    }
    
    public void processData() {
        reader.readLines();
        List linesRead = reader.getLinesRead();
        colSelector.processData(linesRead);
    }
    
    public Vector getRows() {
        Vector rows = new Vector();
        Vector coldata = colSelector.getColumns();
        // transpose the cols
        DataVector col1 = (DataVector)coldata.get(0);
        int numberOfRows = col1.getSize();
        int numberOfCols = coldata.size();
        for (int i=0;i<numberOfRows;i++) {
            DataVector row = new DataVector("row" + (i+1));
            rows.add(row);
            row.setValues(numberOfCols,0.0);
            for (int j=0;j<numberOfCols;j++) {
                DataVector col = (DataVector)coldata.get(j);
                row.setValue(j,col.getValue(i));
            }
        }
        
        return rows;
    }
    
    public Vector getColumns() {
        return colSelector.getColumns();
    }
    
    public String toString() {
        String newline = System.getProperty("line.separator");
        StringBuffer result  = new StringBuffer();
        Vector rows = getRows();
        for (int i=0;i<rows.size();i++) {
            DataVector row = (DataVector)rows.get(i);
            result.append(i+1).append(",");
            result.append(row.toString());
            result.append(newline);
        }
        
        return result.toString();
    }
}
