package oldmcdata.analyzers.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.0
 * 2/28/03 scu - fixed problem in getDataReader(int) - was calling getDataReader(String),
 * when should be calling getDataReader(Integer)
 */

public class OutputDataFileHandler {
    private BufferedReader dataReader;
    private File moeDir;
    private String moeFileStub;

    public OutputDataFileHandler() {

    }

    public void setOutputFileInfo(File moeDirectory, String moeFileStub) {
        this.moeDir = moeDirectory;
        this.moeFileStub = moeFileStub;
    }


    public BufferedReader getDataReader(Integer excursionNumber) {
        String moeFileName = moeFileStub + excursionNumber;
        File moeFile = new File(moeDir, moeFileName);
        if ( !moeFile.exists())
        	return null;
        openFile(moeFile);
        return dataReader;
    }

    public BufferedReader getDataReader(String fullMoeFileName) {
        openFile(new File(fullMoeFileName));
        return dataReader;
    }

    public BufferedReader getDataReader(int excursionNumber) {
        return getDataReader(new Integer(excursionNumber));
    }

    public void openFile(File fileName) {
        try {
            dataReader = new BufferedReader(
                    new FileReader(fileName));
        } catch (IOException e) {
            System.err.println("Can not find or open file: " + fileName.toString());
//            e.printStackTrace();
            System.exit(-1);
        }
    }

}