/*
OldMcData - The Data Farmer
Copyright (C) 2005 Referentia Systems, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*/

package oldmcdata.analyzers.utils;

import java.util.Vector;

import oldmcdata.analyzers.utils.stats.Statistic;
import oldmcdata.analyzers.utils.stats.StatisticFactory;

import org.dom4j.Element;

/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.0
 */

public class SimpleFitnessCalculator implements FitnessCalculator {
    private Statistic statistic;

    public SimpleFitnessCalculator() {
    }

    public void setStatistic(String stat) {
        statistic = StatisticFactory.getInstance(stat);
    }

    public Double calculateFitness(double[] data) {
        statistic.calculateStatistic(data);

        return statistic.getStatistic();
    }

    public Double calculateFitness(String stat, double[] data) {
        setStatistic(stat);

        return calculateFitness(data);
    }
    
    public Double calculateFitness(Vector data) {
        DataVector dv = (DataVector)data.get(0);
        return calculateFitness(dv.getValues());
    }
    
    public void initialize(Element e) {
        
    }

}