package oldmcdata.analyzers.utils.stats;


/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.0
 */

public class Minimum extends AbstractStatistic {

    public Minimum() {
        super("Minimum");
    }

    public void calculateStatistic(double[] data) {
        double minimum = Double.POSITIVE_INFINITY;
        int size = data.length;
        int nanCount = 0;

        for (int i = 0; i < size; i++) {
        	if ( Double.isNaN(data[i]) )
        		nanCount++;
        	else
        		if (data[i] < minimum)
                minimum = data[i];
        }

        if ( nanCount == size )
        	setStatistic(Double.NaN);
        else
        	setStatistic(minimum);
    }
}