package oldmcdata.generators;


import java.util.ArrayList;

import org.dom4j.Element;


/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.3
 */

/** A class to test implementation of Generators
 */
public class TestGenerator extends AbstractGenerator {
    private int count = 0;
    private boolean isIterationEvaluated = false;

    public TestGenerator() {
        super();
    }

    public void initialize() {
        System.out.println(this.getClass().getName() + ":initialize()");
        translator.initialize();
    }


    public void evaluate() {
        System.out.println(this.getClass().getName() + ":evaluate()");
        isIterationEvaluated = true;
        Element iterationElement = studyXMLHandler.getMostRecentIterationElement();
        System.out.println("Most Recent Iteration Element: " + iterationElement.attributeValue("id"));
    }

    public boolean generate() {
        studyXMLHandler.openStudyXMLDocument();
        if (!isIterationEvaluated && count != 0) {
            evaluate();
            isIterationEvaluated = false;
        }

        ArrayList l = new ArrayList();
        l.add("1.0, 1.0, 1.0");
        l.add("25.0, 25.0, 215.0");
        l.add("47.0, two, mealso");
        System.out.println(this.getClass().getName() + ":generate()");
        translator.translate(count, l, studyXMLHandler);
        studyXMLHandler.writeStudyXMLDocument();
        if (count++ > 1)
            return true;
        else
            return false;
    }

}
