/*
 * Created on May 2, 2004
 *
 */
package oldmcdata.postprocessors;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
/**
 *Copyright: 2000 - 2005
 *   Referentia Systems, Inc.
 * @author Stephen C. Upton
 *
 */
public class FileMatcher {
	private PrintWriter logFileWriter;
	private List fileList;
	private Pattern filePattern;
	private File[] listOfFilesInThisDirectory;
	private String fileDirectory;
	private PostProcessTask myTask;
	
	public FileMatcher(PostProcessTask task) {
		myTask = task;
		this.logFileWriter = myTask.getLogFileWriter();
		fileList = new ArrayList();
		this.setFileDirectory(myTask.getFileDirectory());
		this.setMatchingPattern(myTask.getFilePattern());
	}
	
	public void setMatchingPattern(Pattern p){
		filePattern = p;
	}
	
	public void setFileDirectory(String dir) {
		fileDirectory = dir;
	}
	
	private boolean isDirectoryEmpty() {
		File thisDirectory = new File(fileDirectory);
		listOfFilesInThisDirectory = thisDirectory.listFiles();
		if ( listOfFilesInThisDirectory.length == 0 ) {
			logFileWriter.println("No files in this directory: " + fileDirectory);
			return true;			
		}
		return false;		
	}
	
	public void matchFiles() {
		if ( isDirectoryEmpty() ) return;
		// look for files in this directory matching file pattern
		for (int i=0;i<listOfFilesInThisDirectory.length;i++) {
			File fileToCheck = listOfFilesInThisDirectory[i];
			logFileWriter.println("Checking file for match: " + fileToCheck.getName());
			Matcher matcher = filePattern.matcher(fileToCheck.getName());
			if ( matcher.find() )
				fileList.add(fileToCheck);
		}
	
	}
	
	public List getMatchingFiles() {
		if ( fileList.size() == 0 ) {
			logFileWriter.println("No files in this directory: " + fileDirectory);
			logFileWriter.println("matched this pattern: " + filePattern.pattern());
			return fileList;			
		}
		// process these files
		logFileWriter.println("These files matched this pattern: " + filePattern.pattern());
		logFileWriter.println("Using Directory: " + fileDirectory);
		for (Iterator files = fileList.iterator();files.hasNext();) {
			File fileName = (File)files.next();
			logFileWriter.println("File to process: " + fileName.getName());
		}
		
		return fileList;
	}
}
