package oldmcdata.utils;


import java.io.File;
import java.util.List;

import org.dom4j.Element;

/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.0
 */

public interface StudyXMLHandler {
    public void openStudyXMLDocument();

    public void writeStudyXMLDocument();

    public Element getAlgorithmElement();

    public Element getModelRunInformationElement();

    public Element getMostRecentIterationElement();

    public List getMostRecentExcursions();

    public Element getGeneratorAlgorithmElement();

    public Element getAnalyzerAlgorithmElement();

    public String getGeneratorAlgorithmClassName();

    public String getAnalyzerAlgorithmClassName();

    public Element getGeneratorAlgorithmParameters();

    public String getNumberReplicates();

    public List getInitialSeeds();

    public List getVariables();

    public String getEvaluatorClassName();

    public Element getEvaluatorParameters();

    public Element getModelIdentificationElement();
    
	public Element getSubmissionParametersElement();    

    public Element getModelParametersElement();

    public File getStudyDirectory();

    public File getExcursionDirectory();
    
    public File getPlaybackDirectory();
    
    public File getMOEDirectory();

    public File getStudyFile();

    public String getStudyFileName();

    public String getModelName();

    public String getModelMajorVersion();

    public String getModelMinorVersion();

    public String getModelVersion();

    public List getMOEFileNames();
    
	public File getBaseCaseFileName();    

    public List getIterations();

    public Element getIteration(String iterationID);

    public List getExcursionValues(Element excursion);

    public List getExcursions(Element iterationElement);

    public List getVariableNames();

    public List getMOEFileNames(Element iterationElement);

    public boolean isExcursionElementExist(String elementName);

    public void clearMostRecentIterationElement();
}
